# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url_base = "https://www.dell.com/support/home/fr-fr/drivers/driversdetails?driverid=v9c51&oscode=wt64a&productcode=dell-display-manager-2.0"

    print("URL used is: %s" % url_base)

    # Getting the download page link
    links = bs_find_all(url_base, 'a','href', proxies=proxies)
    exe_file = None
    for link in links:
        if link['href'].endswith('.exe'):
            href = link['href']
            download_url = href
            latest_bin = href.split('/')[-1]
            break

    # Getting the version
    version_label = bs_find(
        url_base,
        'h2',
        'id',
        "driverVersionForDriver",
        proxies=proxies,
    )
    version = version_label.fetchNextSiblings()[0].text.split(',', 1)[0][1:]

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s %s" % (latest_bin, version))
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Checking version from file
    version_from_file = get_version_from_binary(latest_bin)
    if Version(version_from_file, 4) != Version(version, 4) and version_from_file != "":
        print(
            "Changing version to the version number of the binary (from: %s to: %s)"
            % (version, version_from_file)
        )
        # os.rename(latest_bin, latest_bin.replace(version, version_from_file))
        version = version_from_file
    else:
        print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print(
            "Software version updated (from: %s to: %s)"
            % (control.get_software_version(), Version(version))
        )
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
